searchNodes=[{"doc":"Estructura is a set of extensions for Elixir structures, such as Access implementation, Enumerable and Collectable implementations, validations and test data generation via StreamData . Estructura simplifies the following Access implementation for structs Enumerable implementation for structs (as maps) Collectable implementation for one of struct’s fields (as MapSet does) StreamData generation of structs for property-based testing Use Options use Estructura accepts four keyword arguments. access: true | false | :lazy whether to generate the Access implementation, default true ; when true or :lazy , it also produces put/3 and get/3 methods to be used with coercion and validation , when :lazy , instances of Estructura.Lazy are understood as values coercion: boolean() | [key()] whether to generate the bunch of coerce_×××/1 functions to be overwritten by implementations, default false validation: boolean() | [key()] whether to generate the bunch of validate_×××/1 functions to be overwritten by implementations, default false enumerable: boolean() whether to generate the Enumerable porotocol implementation, default false collectable: false | key() whether to generate the Collectable protocol implementation, default false ; if non-falsey atom is given, it must point to a struct field where Collectable would collect. Should be one of list() , map() , MapSet.t() , bitstribg() generator: %{optional(key()) =&gt; Estructura.Config.generator()} the instructions for the __generate__/{0,1} functions that would produce the target structure values suitable for usage in StreamData property testing; the generated __generator__/1 function is overwritable. Please note, that setting coercion and/or validation to truthy values has effect if and only if access has been also set to true . Typical example of usage would be: defmodule MyStruct do use Estructura , access : true , coercion : [ :foo ] , # requires `c:MyStruct.Coercible.coerce_foo/1` impl validation : true , # requires `c:MyStruct.Validatable.validate_×××/1` impls enumerable : true , collectable : :bar , generator : [ foo : { StreamData , :integer } , bar : { StreamData , :list_of , [ { StreamData , :string , [ :alphanumeric ] } ] } , baz : { StreamData , :fixed_map , [ [ key1 : { StreamData , :integer } , key2 : { StreamData , :integer } ] ] } ] defstruct foo : 42 , bar : [ ] , baz : %{ } @impl MyStruct.Coercible def coerce_foo ( value ) when is_integer ( value ) , do : { :ok , value } def coerce_foo ( value ) when is_float ( value ) , do : { :ok , round ( value ) } def coerce_foo ( value ) when is_binary ( value ) do case Integer . parse ( value ) do { value , &quot;&quot; } -&gt; { :ok , value } _ -&gt; { :error , &quot; \#{ value } is not a valid integer value&quot; } end end def coerce_foo ( value ) , do : { :error , &quot;Cannot coerce value given for `foo` field ( \#{ inspect ( value ) } )&quot; } @impl MyStruct.Validatable def validate_foo ( value ) when value &gt;= 0 , do : { :ok , value } def validate_foo ( _ ) , do : { :error , &quot;:foo must be positive&quot; } @impl MyStruct.Validatable def validate_bar ( value ) , do : { :ok , value } @impl MyStruct.Validatable def validate_baz ( value ) , do : { :ok , value } end The above would allow the following to be done with the structure: s = % MyStruct { } put_in s , [ :foo ] , :forty_two #⇒ %MyStruct{foo: :forty_two, bar: [], baz: %{}} for i &lt;- [ 1 , 2 , 3 ] , into : s , do : i #⇒ %MyStruct{foo: 42, bar: [1, 2, 3], baz: %{}} Enum . map ( s , &amp; elem ( &amp;1 , 1 ) ) #⇒ [42, [], %{}] MyStruct . __generator__ ( ) |&gt; Enum . take ( 3 ) #⇒ [ # %MyStruct{bar: [], baz: %{key1: 0, key2: 0}, foo: -1}, # %MyStruct{bar: [&quot;g&quot;, &quot;xO&quot;], baz: %{key1: -1, key2: -2}, foo: 2}, # %MyStruct{bar: [&quot;&quot;, &quot;&quot;, &quot;&quot;], baz: %{key1: -3, key2: 1}, foo: -1} # ] Coercion When coercion: true | [key()] is passed as an argument to use Estructura , the nested behaviour Coercible is generated and the target module claims to implement it. To make a coercion work with MyStruct.put/3 and put_in/3 provided by Access implementation, the consumer module should implement MyStruct.Coercible behaviour. For the consumer convenience, the warnings for not implemented functions will be issued by compiler. Validation When validation: true | [key()] is passed as an argument to use Estructura , the nested behaviour Validatable is generated and the target module claims to implement it. To make a validation work with MyStruct.put/3 and put_in/3 provided by Access implementation, the consumer module should implement MyStruct.Validatable behaviour. For the consumer convenience, the warnings for not implemented functions will be issued by compiler. Generation If generator keyword argument has been passed, MyStruct.__generate__/{0,1} can be used to generate instances of this struct for StreamData property based tests. property &quot;generation&quot; do check all % MyStruct { foo : foo , bar : bar , baz : baz } &lt;- MyStruct . __generator__ ( ) do assert match? ( %{ key1 : v1 , key2 : v2 } when is_integer ( v1 ) and is_integer ( v2 ) , baz ) assert is_integer ( foo ) assert is_binary ( bar ) end end Lazy If access: :lazy is passed as an option, the struct content might be instantiated lazily, upon first access through Kernel.×××_in/{2,3} family. This might be explicitly helpful when the real content requires a significant time to load and/or store. Consider the full response from the web server, including the gzipped content, which might in turn be a huge text file. Or an attachment to an email. Instead of unarchiving the content, one might use Lazy as defmodule Response do @moduledoc false use Estructura , access : :lazy def extract ( file ) , do : { :ok , ZipHelper . unzip ( file ) } defstruct __lazy_data__ : nil , file : Estructura.Lazy . new ( &amp; Response . extract / 1 ) end response = % Response { __lazy_data__ : zipped_content } # immediate response response |&gt; get_in ( [ :file ] ) # unzip and return { unzipped , struct_with_cached_value } = response |&gt; pop_in ( [ :file ] ) # unzip and return the value, alter the struct with it See Estructura.Lazy for details and options, see Estructura.LazyMap for the implementation of lazy map.","ref":"Estructura.html","title":"Estructura","type":"module"},{"doc":"Calculates the difference between two estructures and returns a tuple with the first element containing same values and the second one with diffs. This function accepts maps but this options should be used as a last resort because structs are 4–6 times faster. Examples defmodule M do use Estructura , enumerable : true defstruct a : true , b : false end Estructura . diff ( struct ( M , [ ] ) , struct ( M , b : true ) , :diff ) #⇒{%{a: true}, %{b: [false, true]}} Estructura . diff ( %{ a : true , b : false } , %{ a : true , b : true } , :overlap ) #⇒ %{a: true} Estructura . diff ( %{ a : true , b : false } , %{ a : true , b : true } , :disjoint ) #⇒ %{b: [false, true]}","ref":"Estructura.html#diff/3","title":"Estructura.diff/3","type":"function"},{"doc":"Diff return type","ref":"Estructura.html#t:diff_result/0","title":"Estructura.diff_result/0","type":"type"},{"doc":"The nested struct with helpers to easily describe it and produce validation, coercion, and generation helpers.","ref":"Estructura.Nested.html","title":"Estructura.Nested","type":"module"},{"doc":"DSL helper to produce coerce callbacks. The syntax is kinda weird, but bear with it, please. It’s known to produce warnings in credo , I’m working on it. coerce do def data . age ( age ) when is_float ( age ) , do : { :ok , age } def data . age ( age ) when is_integer ( age ) , do : { :ok , 1.0 * age } def data . age ( age ) when is_binary ( age ) , do : { :ok , String . to_float ( age ) } def data . age ( age ) , do : { :error , &quot;Could not cast \#{ inspect ( age ) } to float&quot; } end","ref":"Estructura.Nested.html#coerce/1","title":"Estructura.Nested.coerce/1","type":"macro"},{"doc":"Declares the shape of the target nested map. the values might be: :string | :integer or another simple type understood by StreamData [type] to declare a list of elements of a single type map to declare a nesting level; in such a case, the module with the FQN is created, carrying the struct of the same behaviour mfa tuple pointing out to the generator for this value Example defmodule User do use Estructura.Nested shape %{ name : :string , address : %{ city : :string , street : %{ name : [ :string ] , house : :string } } , data : %{ age : :float } } end % User { } would result in % User { address : % User.Address { city : nil , street : % User.Address.Street { house : nil , name : [ ] } } , data : % User.Data { age : nil } , name : nil }","ref":"Estructura.Nested.html#shape/1","title":"Estructura.Nested.shape/1","type":"macro"},{"doc":"DSL helper to produce validate callbacks. The syntax is kinda weird, but bear with it, please. It’s known to produce warnings in credo , I’m working on it. validate do def address . street . postal_code ( &lt;&lt; ?0 , code :: binary - size ( 4 ) &gt;&gt; ) , do : { :ok , code } def address . street . postal_code ( code ) , do : { :error , &quot;Not a postal code ( \#{ inspect ( code ) } )&quot; } end","ref":"Estructura.Nested.html#validate/1","title":"Estructura.Nested.validate/1","type":"macro"},{"doc":"The field stub allowing lazy instantiation of Estructura fields.","ref":"Estructura.Lazy.html","title":"Estructura.Lazy","type":"module"},{"doc":"Apply the lazy getter to the data passed as an argument Examples iex&gt; lazy = Estructura.Lazy . new ( &amp; System . fetch_env / 1 ) ...&gt; Estructura.Lazy . apply ( lazy , &quot;LANG&quot; ) . value System . fetch_env ( &quot;LANG&quot; )","ref":"Estructura.Lazy.html#apply/3","title":"Estructura.Lazy.apply/3","type":"function"},{"doc":"Create the new struct with the getter passed as an argument","ref":"Estructura.Lazy.html#new/2","title":"Estructura.Lazy.new/2","type":"function"},{"doc":"Validates if the value is not stale yet according to expires_in setting","ref":"Estructura.Lazy.html#stale?/1","title":"Estructura.Lazy.stale?/1","type":"function"},{"doc":"","ref":"Estructura.Lazy.html#t:cached/0","title":"Estructura.Lazy.cached/0","type":"type"},{"doc":"","ref":"Estructura.Lazy.html#t:getter/0","title":"Estructura.Lazy.getter/0","type":"type"},{"doc":"","ref":"Estructura.Lazy.html#t:key/0","title":"Estructura.Lazy.key/0","type":"type"},{"doc":"","ref":"Estructura.Lazy.html#t:t/0","title":"Estructura.Lazy.t/0","type":"type"},{"doc":"","ref":"Estructura.Lazy.html#t:value/0","title":"Estructura.Lazy.value/0","type":"type"},{"doc":"The implementation of lazy map implementing lazy Access for its keys. Estructura.LazyMap is backed by the “raw” object and a key-value pairs where values might be instances of Estructura.Lazy . If this is a case, they will be accessed through Lazy implementation. Values might be also raw values, which makes LazyMap a drop-in replacement of standard Elixir maps, assuming they are accessed through Access only (e. g. map[:key] and not map.key .)","ref":"Estructura.LazyMap.html","title":"Estructura.LazyMap","type":"module"},{"doc":"Eagerly instantiates the data","ref":"Estructura.LazyMap.html#fetch_all/1","title":"Estructura.LazyMap.fetch_all/1","type":"function"},{"doc":"Returns all the keys of the underlying map","ref":"Estructura.LazyMap.html#keys/1","title":"Estructura.LazyMap.keys/1","type":"function"},{"doc":"Creates new instance of LazyMap with a second parameter being a backed up object, which would be used for lazy retrieving data for values, when value is an instance of Estructura.Lazy . Examples iex&gt; lm = Estructura.LazyMap . new ( ...&gt; [ int : Estructura.Lazy . new ( &amp; Estructura.LazyInst . parse_int / 1 ) ] , &quot;42&quot; ) ...&gt; get_in lm , [ :int ] 42","ref":"Estructura.LazyMap.html#new/2","title":"Estructura.LazyMap.new/2","type":"function"},{"doc":"","ref":"Estructura.LazyMap.html#t:t/0","title":"Estructura.LazyMap.t/0","type":"type"},{"doc":"The configuration of the Estructura that is built from the parameters, passed as a second argument in a call to use Estructura . One normally does not need to meddle with this module.","ref":"Estructura.Config.html","title":"Estructura.Config","type":"module"},{"doc":"The generator to be passed to use Estructura should be given in one of these forms","ref":"Estructura.Config.html#t:generator/0","title":"Estructura.Config.generator/0","type":"type"},{"doc":"The structure key","ref":"Estructura.Config.html#t:key/0","title":"Estructura.Config.key/0","type":"type"},{"doc":"The configuration of Estructura","ref":"Estructura.Config.html#t:t/0","title":"Estructura.Config.t/0","type":"type"},{"doc":"The structure value","ref":"Estructura.Config.html#t:value/0","title":"Estructura.Config.value/0","type":"type"},{"doc":"Full Example","ref":"Estructura.Full.html","title":"Estructura.Full","type":"module"},{"doc":"See Estructura.Full.__generator__/1","ref":"Estructura.Full.html#__generator__/0","title":"Estructura.Full.__generator__/0","type":"function"},{"doc":"Returns the generator to be used in StreamData -powered property testing, based on the specification given to use Estructura , which contained shape % Estructura.Config { access : true , coercion : [ :foo ] , validation : true , collectable : :bar , enumerable : true , generator : [ foo : { StreamData , :integer , [ 0 .. 1000 ] } , bar : { StreamData , :string , [ :alphanumeric ] } , baz : { StreamData , :fixed_map , [ [ key1 : { StreamData , :integer } , key2 : { StreamData , :integer } ] ] } , zzz : &amp; Estructura.Full . zzz_generator / 0 ] } The argument given would be used as a template to generate new values.","ref":"Estructura.Full.html#__generator__/1","title":"Estructura.Full.__generator__/1","type":"function"},{"doc":"Gets the value for the given key from the structure","ref":"Estructura.Full.html#get/3","title":"Estructura.Full.get/3","type":"function"},{"doc":"Puts the value for the given key into the structure, passing coercion and validation, returns {:ok, updated_struct} or {:error, reason} if there is no such key","ref":"Estructura.Full.html#put/3","title":"Estructura.Full.put/3","type":"function"},{"doc":"Puts the value for the given key into the structure, passing coercion and validation, returns the value or raises if there is no such key","ref":"Estructura.Full.html#put!/3","title":"Estructura.Full.put!/3","type":"function"},{"doc":"Nested example. The source code of the file follows. use Estructura.Nested shape %{ name : :string , address : %{ city : :string , street : %{ name : [ :string ] , house : :string } } , data : %{ age : :float } } coerce do def data . age ( age ) when is_float ( age ) , do : { :ok , age } def data . age ( age ) when is_integer ( age ) , do : { :ok , 1.0 * age } def data . age ( age ) when is_binary ( age ) do age |&gt; Float . parse ( ) |&gt; case do { age , &quot;&quot; } -&gt; { :ok , age } { age , _rest } -&gt; { :ok , age } :error -&gt; { :ok , 0.0 } end end end validate do def address . street . house ( house ) , do : { :ok , house } end Now one can cast it from map as below User . cast %{ address : %{ city : &quot;London&quot; , street : %{ name : &quot;Baker&quot; , house : &quot;221 Bis&quot; } } , data : %{ age : 32 } , name : &quot;Watson&quot; } { :ok , % Estructura.User { address : % Estructura.User.Address { city : &quot;London&quot; , street : % Estructura.User.Address.Street { house : &quot;221 Bis&quot; , name : &quot;Baker&quot; } } , data : % Estructura.User.Data { age : 32.0 } , name : &quot;Watson&quot; } }","ref":"Estructura.User.html","title":"Estructura.User","type":"module"},{"doc":"See Estructura.User.__generator__/1","ref":"Estructura.User.html#__generator__/0","title":"Estructura.User.__generator__/0","type":"function"},{"doc":"Returns the generator to be used in StreamData -powered property testing, based on the specification given to use Estructura.Nested , which contained shape %{ address : %{ city : :string , street : %{ house : :string , name : [ :string ] } } , data : %{ age : :float } , name : :string } coerce def coerce_age ( age ) when is_float ( age ) do { :ok , age } end def coerce_age ( age ) when is_integer ( age ) do { :ok , 1.0 * age } end def coerce_age ( age ) when is_binary ( age ) do age |&gt; Float . parse ( ) |&gt; case do { age , &quot;&quot; } -&gt; { :ok , age } { age , _rest } -&gt; { :ok , age } :error -&gt; { :ok , 0.0 } end end validate def validate_house ( house ) do { :ok , house } end The argument given would be used as a template to generate new values.","ref":"Estructura.User.html#__generator__/1","title":"Estructura.User.__generator__/1","type":"function"},{"doc":"Casts the map representation as given to Estructura.Nested.shape/1 to the nested Estructura instance.","ref":"Estructura.User.html#cast/1","title":"Estructura.User.cast/1","type":"function"},{"doc":"","ref":"Estructura.User.html#cast!/1","title":"Estructura.User.cast!/1","type":"function"},{"doc":"Gets the value for the given key from the structure","ref":"Estructura.User.html#get/3","title":"Estructura.User.get/3","type":"function"},{"doc":"Safely parses the json, applying all the specified validations and coercions","ref":"Estructura.User.html#parse/1","title":"Estructura.User.parse/1","type":"function"},{"doc":"Same as parse/1 but either returns the result of successful parsing or raises","ref":"Estructura.User.html#parse!/1","title":"Estructura.User.parse!/1","type":"function"},{"doc":"Puts the value for the given key into the structure, passing coercion and validation, returns {:ok, updated_struct} or {:error, reason} if there is no such key","ref":"Estructura.User.html#put/3","title":"Estructura.User.put/3","type":"function"},{"doc":"Puts the value for the given key into the structure, passing coercion and validation, returns the value or raises if there is no such key","ref":"Estructura.User.html#put!/3","title":"Estructura.User.put!/3","type":"function"},{"doc":"Extensions for Elixir structures.","ref":"readme.html","title":"Estructura","type":"extras"},{"doc":"def deps do [ { :estructura , &quot;~&gt; 0.1&quot; } , # optionally you might want to add `boundary` library # it is used by `estructura` and many other projects # more info: https://hexdocs.pm/boundary { :boundary , &quot;~&gt; 0.9&quot; , runtime : false } ] end I suggest adding boundary as a dependency since that is used in this project.","ref":"readme.html#installation","title":"Estructura - Installation","type":"extras"},{"doc":"0.5.5  — export declarations of both Estructura and Estructura.Nested to docs 0.5.4  — Estructura.Nested allows cast/1 to cast nested structs from maps 0.5.3  — Estructura.diff/3 now understands maps 0.5.2  — Estructura.diff/3 0.5.1  — [BUG] Fixed Collectable and Enumerable injected implementations 0.5.0  — Estructura.Nested for nested structures with validation, coercion, and generation 0.4.2  — [BUG] Fixed wrong spec for put!/3 0.4.1  — Estructura.LazyMap.keys/1 , Estructura.LazyMap.fetch_all/1 0.4.0  — Estructura.Lazy , Estructura.LazyMap 0.3.2  — put!/3 0.3.0  — coercion and validation are now injected as behaviours 0.2.0  — coercion , validation , put/3","ref":"readme.html#changelog","title":"Estructura - Changelog","type":"extras"},{"doc":"","ref":"readme.html#documentation","title":"Estructura - Documentation","type":"extras"}]